﻿using C1.Win;
using C1.Win.FlexGrid;
using C1.Win.Input.Validation;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FlexEditorValidatate6
{
    public partial class MyDateEdit : UserControl, IEmbeddedEditor
    {
        public MyDateEdit()
        {
            InitializeComponent();

            this.c1DateEdit1.FormatType = C1.Win.Input.FormatType.ShortDate;

            //Test for Validation => this works fine here.
            this.c1DateEdit1.PostValidation.Validation = C1.Win.Input.PostValidationType.PostValidatingEvent;
            this.c1DateEdit1.PostValidation.Validating += PostValidation_Validating;
        }

        private void PostValidation_Validating(object sender, C1.Win.Input.PostValidationEventArgs e)
        {
            string text = this.c1DateEdit1.Text;

            //Test: check that date is not before today:
            if (((DateTime)e.Value) < DateTime.Today)
            {
                e.Succeeded = false;
                e.ErrorInfo.ErrorMessage = "Not before today";
            }
        }

        public void Initialize(object value, IDictionary attrs)
        {

            if (attrs.Contains("Format"))
                attrs.Remove("Format");
            c1DateEdit1.Initialize(value, attrs);
            //Den Wert auswerten: wenn String, dann MUSS es eigentlich ein TimeSpan sein.
            if (value is String stringval)
            {
                DateTime datParsed = DateTime.Parse(stringval);
                this.c1DateEdit1.Value = datParsed;
            }
            else if (value == null)
            {
                //Null: 
                this.c1DateEdit1.Value = DateTime.Today;
            }
        }

        public object GetValue()
        {
            return (c1DateEdit1 as IEmbeddedEditor).GetValue();
        }

        public bool IsValueValid()
        {
            return (c1DateEdit1 as IEmbeddedEditor).IsValueValid();
        }

        public void UpdateBounds(Rectangle rc)
        {
            this.Location = new Point(rc.X, rc.Y);
            this.Width = rc.Width;
            this.Height = rc.Height;
        }

        public bool HandleFinishEdit(KeyEventArgs e)
        {
            //Console.WriteLine ("C1EditorKeyDownFinishEdit");
            if (e.KeyCode == Keys.Escape || e.KeyCode == Keys.Enter)
                return true;
            else return false;
        }

        public void SetFormat(string format)
        {
            throw new NotImplementedException();
        }

        public UITypeEditorEditStyle GetEditStyle()
        {
            return UITypeEditorEditStyle.None;
        }
    }
}
