﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FlexEditorValidate48
{
  public partial class MyDateEdit : UserControl, IC1EmbeddedEditor
  {
    /// <summary>Initialbreite des Controls. Nötig, da die Breite bei unsichtbarem Control auf "-1" gesetzt wird.</summary>
    private int intInitialWidth = -1;
    /// <summary>Initialhöhe des Controls. Nötig, da die Höhe bei unsichtbarem Control auf "-1" gesetzt wird.</summary>
    private int intInitialHeight = -1;

    public MyDateEdit()
    {
      InitializeComponent();

      this.intInitialWidth = this.Width;
      this.intInitialHeight = this.Height;

      this.c1DateEdit1.FormatType = C1.Win.C1Input.FormatTypeEnum.ShortDate;
    }

    public void C1EditorInitialize(object value, IDictionary editorAttributes)
    {
      //Den Wert auswerten: wenn String, dann MUSS es eigentlich ein TimeSpan sein.
      if (value is String stringval)
      {
        DateTime datParsed = DateTime.Parse(stringval);
        this.c1DateEdit1.Value  = datParsed;
      }
      else if (value == null)
      {
        //Null: 
        this.c1DateEdit1.Value = DateTime.Today;
      }
    }

    public object C1EditorGetValue()
    {
      return ((DateTime)this.c1DateEdit1.Value).ToShortDateString();
    }

    public bool C1EditorValueIsValid()
    {
      return true;
    }

    public void C1EditorUpdateBounds(Rectangle rc)
    {
      //Wenn hier "-1" steht, dann sind wir aus dem Bild gescrollt.
      if (rc.Height != -1 && rc.Width != -1)
      {
        this.Location = new Point(rc.X, rc.Y);
        //Editor-Größe auf die Defaults schalten.
        this.Width = this.intInitialWidth;
        this.Height = this.intInitialHeight;
      }
      else
      {
        //Editor ist aus dem Bild gescrollt. Die Höhe/Breite von -1 übernehmen.
        this.Width = -1;
        this.Height = -1;
      }
    }

    public bool C1EditorKeyDownFinishEdit(KeyEventArgs e)
    {
      //Console.WriteLine ("C1EditorKeyDownFinishEdit");
      if (e.KeyCode == Keys.Escape || e.KeyCode == Keys.Enter)
        return true;
      else return false;
    }

    public string C1EditorFormat(object value, string mask)
    {
      throw new NotImplementedException();
    }

    public UITypeEditorEditStyle C1EditorGetStyle()
    {
      return UITypeEditorEditStyle.None;
    }
  }
}
